### org.jfree.layouting.normalizer.content

# Interface Normalizer

All Superinterfaces:
  StatefullComponent

Known Implementing Classes:
  ChainingNormalizer, ContentNormalizer, RecordingContentNormalizer

`public interface Normalizer`
`extends StatefullComponent`

The normalizer is the first stage of the content processing. A normalizer is responsible for auto-generating content and for assigning styles to the logical document tree.

Author:
  Thomas Morgner

  ## Method Summary

  `void`

  `addText(String text)`
    Adds text content to the current element.

  `void`

  `endDocument()`
    Ends the document.

  `void`

  `endElement()`
    Ends the current element.

  `Renderer`

  `getRenderer()`
    Returns the renderer.

  `void`

  `handlePageBreak(CSSValue pageName, PseudoPage[] pseudoPages)`

  `void`

  `startDocument()`
    Start document is the first call to the normalizer.

  `void`

  `startElement(String namespace, String tag, AttributeMap attributes)`
    Starts a new element.

  ### Methods inherited from interface org.jfree.layouting.StatefullComponent

  `saveState`

## Method Details

### addText

    public void addText(String text)
                throws NormalizationException,
                       IOException

> Adds text content to the current element.
> Parameters:
>   `text` -
> Throws:
>   `NormalizationException` -

### endDocument

    public void endDocument()
                throws NormalizationException,
                       IOException

> Ends the document. No other events will be fired against this normalizer once this method has been called.
> Throws:
>   `NormalizationException` -

### endElement

    public void endElement()
                throws NormalizationException,
                       IOException

> Ends the current element. The namespace and tagname are given for convienience.
> Parameters:
> Throws:
>   `NormalizationException` -

### getRenderer

    public Renderer getRenderer()

> Returns the renderer. The renderer is the last step in the processing chain. The ModelBuilder and ContentGenerator steps are considered internal, as they may refeed the normalizer.
> Returns:

### handlePageBreak

    public void handlePageBreak(CSSValue pageName,
                                PseudoPage[] pseudoPages)
                throws NormalizationException

### startDocument

    public void startDocument()
                throws NormalizationException,
                       IOException

> Start document is the first call to the normalizer. At this point, all meta-data has been given and the document context is filled correctly. Starting the document also starts a new PageContext.
> Throws:
>   `NormalizationException` -

### startElement

    public void startElement(String namespace,
                             String tag,
                             AttributeMap attributes)
                throws NormalizationException,
                       IOException

> Starts a new element. The element uses the given namespace and tagname. The element's attributes are given as collection, each attribute is keyed with a namespace and attributename. The values contained in the attributes are not defined.
> Parameters:
>   `namespace` -
>   `tag` -
>   `attributes` -
> Throws:
>   `NormalizationException` -